/* zf16r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer iter;
} zf16rr_;

#define zf16rr_1 zf16rr_

/* Table of constant values */

static integer c__16 = 16;

/* Subroutine */ int zf16r_c(R_fp f, real *a, real *b, real *eps, real *root,
        integer *itmax, integer *ierr)
{
    /* Initialized data */

    static real zero = 0.f;

    /* System generated locals */
    integer i__1;

    /* Local variables */
    static real rmid, xmid;
    static integer i__;
    static real r__;
    extern /* Subroutine */ int utzf10_c(integer *, integer *);
    static real dx;

/*      F(X)=0  (A,B) */
    *ierr = 0;
    rmid = (real)(*f)(b);
    r__ = (real)(*f)(a);
    if (r__ * rmid < zero) {
        goto L10;
    }
    *ierr = 66;
    goto L60;
L10:
    if (r__ >= zero) {
        goto L20;
    }
    *root = *a;
    dx = *b - *a;
    goto L30;
L20:
    *root = *b;
    dx = *a - *b;
L30:
    i__1 = *itmax;
    for (i__ = 1; i__ <= i__1; ++i__) {
        zf16rr_1.iter = i__;
        dx /= 2;
        xmid = *root + dx;
        rmid = (real)(*f)(&xmid);
        if (rmid <= zero) {
            *root = xmid;
        }
        if (abs(dx) < abs(*eps) || rmid == zero) {
            goto L50;
        }
/* L40: */
    }
    *ierr = 65;
L60:
    utzf10_c(ierr, &c__16);
L50:
    return 0;
} /* zf16r_c */
